diff --git a/src/postgres/src/backend/commands/user.c b/src/postgres/src/backend/commands/user.c
index e935e53ef545..2f77f709faee 100644
--- a/src/postgres/src/backend/commands/user.c
+++ b/src/postgres/src/backend/commands/user.c
@@ -1397,6 +1397,12 @@ ReassignOwnedObjects(ReassignOwnedStmt *stmt)
 			ereport(ERROR,
 					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
 					 errmsg("permission denied to reassign objects")));
+
+		if (superuser_arg(roleid) && !superuser())
+			ereport(ERROR,
+					(errcode(ERRCODE_INSUFFICIENT_PRIVILEGE),
+					 errmsg("non-superuser cannot reassign objects "
+					 		"from superuser")));
 	}
 
 	/* Must have privileges on the receiving side too */
diff --git a/src/postgres/src/test/regress/expected/yb_dependency.out b/src/postgres/src/test/regress/expected/yb_dependency.out
index 3f3c87436079..9930899e0eb9 100644
--- a/src/postgres/src/test/regress/expected/yb_dependency.out
+++ b/src/postgres/src/test/regress/expected/yb_dependency.out
@@ -4,14 +4,18 @@
 CREATE ROLE regress_user1;
 CREATE ROLE regress_user2;
 CREATE ROLE regress_user3;
+CREATE ROLE non_sys_superuser SUPERUSER;
 GRANT regress_user1 TO regress_user3;
 GRANT regress_user2 TO regress_user3;
 SET SESSION AUTHORIZATION yb_db_admin;
 REASSIGN OWNED BY regress_user1 TO regress_user2;
 REASSIGN OWNED BY regress_user2 TO regress_user1;
--- should fail, database systems
+-- should fail, cannot reassign objects owned by superuser
 REASSIGN OWNED BY postgres TO yb_db_admin;
-ERROR:  cannot reassign ownership of objects owned by role postgres because they are required by the database system
+ERROR:  non-superuser cannot reassign objects from superuser
+-- should fail, assigning from superuser to non-superuser
+REASSIGN OWNED BY non_sys_superuser TO yb_db_admin;
+ERROR:  non-superuser cannot reassign objects from superuser
 -- should fail, user needs privileges on both old and new role
 SET SESSION AUTHORIZATION regress_user1;
 REASSIGN OWNED BY regress_user1 TO regress_user2;
diff --git a/src/postgres/src/test/regress/sql/yb_dependency.sql b/src/postgres/src/test/regress/sql/yb_dependency.sql
index e18d7d3f975f..180046ba6425 100644
--- a/src/postgres/src/test/regress/sql/yb_dependency.sql
+++ b/src/postgres/src/test/regress/sql/yb_dependency.sql
@@ -4,13 +4,16 @@
 CREATE ROLE regress_user1;
 CREATE ROLE regress_user2;
 CREATE ROLE regress_user3;
+CREATE ROLE non_sys_superuser SUPERUSER;
 GRANT regress_user1 TO regress_user3;
 GRANT regress_user2 TO regress_user3;
 SET SESSION AUTHORIZATION yb_db_admin;
 REASSIGN OWNED BY regress_user1 TO regress_user2;
 REASSIGN OWNED BY regress_user2 TO regress_user1;
--- should fail, database systems
+-- should fail, cannot reassign objects owned by superuser
 REASSIGN OWNED BY postgres TO yb_db_admin;
+-- should fail, assigning from superuser to non-superuser
+REASSIGN OWNED BY non_sys_superuser TO yb_db_admin;
 -- should fail, user needs privileges on both old and new role
 SET SESSION AUTHORIZATION regress_user1;
 REASSIGN OWNED BY regress_user1 TO regress_user2;
